unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.ExtCtrls, superobject, httpsend, ssl_openssl;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    ListView1: TListView;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button6: TButton;
    od: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure CreateConnector();
  end;

var
  Form1: TForm1;
  chat_id: string;
  http: THTTPSend;
  last_id: string;

const
  bot_key = '313338023:AAFuEsfypP9rXBp4-P9VwgEJB77x1m2xLJg';
  bound = 'delphi-dev.ru_20162004';

implementation

{$R *.dfm}

{ TForm1 }
  //    
function GetBoundary(endf: Boolean): string;
begin
  if (endf) then
    Result := '--' + bound + sLineBreak
  else
    Result := '--' + bound + '--' + sLineBreak;

end;

function UrlEncode(const S: string): string;
var
  i: integer;
  u: ansistring;
  r: ansistring;
begin
  r := '';
  u := ansistring(UTF8Encode(S));
  for i := 1 to Length(u) do
  begin
    case u[i] of
      'A'..'Z', 'a'..'z', '0'..'9', '-', '_', '.':
        r := r + u[i];
    else
      r := r + '%' + ansistring(IntToHex(Ord(u[i]), 2));
    end;
  end;
  Result := string(r);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  s: string;
  jo: ISuperObject;
  list: TStringList;
begin
  s := 'https://api.telegram.org/bot' + bot_key + '/GetMe';
  if http.HTTPMethod('GET', s) then
  begin
    list := TStringList.Create;
    list.LoadFromStream(http.Document);
    jo := SO(list.Text);
    if jo.B['ok'] = true then
    begin
      Label1.Caption := jo.S['result.id'];
      Label2.Caption := jo.S['result.first_name'];
      Label3.Caption := jo.S['result.username'];
    end;

  end;
  list.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  s: string;
begin
  if ListView1.SelCount = 0 then
  begin
    ShowMessage('  ');
    Exit;
  end;
  http.Document.Clear;
  http.Headers.Clear;
  s := Format('https://api.telegram.org/bot%s/sendmessage?chat_id=%s&text=%s', [bot_key, listview1.Selected.Caption, urlencode(edit1.Text)]);
  if http.HTTPMethod('GET', s) then
    Memo1.Lines.LoadFromStream(http.Document);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  s: AnsiString;
  f: TFileStream;
begin
  if not od.Execute() then
    Exit;

  http.Document.Clear;
  http.Headers.Clear;
  //
  http.MimeType := 'multipart/form-data; boundary=' + bound;
  s := GetBoundary(true) + 'Content-Disposition: form-data; name="chat_id";' + sLineBreak + sLineBreak + ListView1.Selected.Caption + sLineBreak + sLineBreak;
  http.Document.Write(PAnsiChar(s)^, Length(s));
  s := GetBoundary(true) + 'Content-Disposition: form-data; name="photo"; filename=' + extractfilename(od.FileName) + sLineBreak + 'Content-Type: multipart/form-data' + sLineBreak + sLineBreak;
  http.Document.Write(PAnsiChar(s)^, Length(s));
  f := TFileStream.Create(od.FileName, fmOpenRead);
  f.Position := 0;
  http.Document.CopyFrom(f, f.Size);
  f.Free;
  s := sLineBreak + GetBoundary(true);
  http.Document.Write(PAnsiChar(s)^, Length(s));
  s := 'Content-Disposition: form-data; name="caption";' + sLineBreak + slinebreak + AnsiToUtf8(' ') + sLineBreak + getboundary(false);
  http.Document.Write(PAnsiChar(s)^, Length(s));
  s := Format('https://api.telegram.org/bot%s/sendphoto', [bot_key]);
  if http.HTTPMethod('POST', s) then
    Memo1.Lines.LoadFromStream(http.Document);

end;

procedure TForm1.Button4Click(Sender: TObject);
var
  s: AnsiString;
  f: TFileStream;
begin
  if not od.Execute() then
    Exit;

  http.Document.Clear;
  http.Headers.Clear;
  //
  http.MimeType := 'multipart/form-data; boundary=' + bound;
  s := GetBoundary(true) + 'Content-Disposition: form-data; name="chat_id";' + sLineBreak + sLineBreak + ListView1.Selected.Caption + sLineBreak + sLineBreak;
  http.Document.Write(PAnsiChar(s)^, Length(s));
  s := GetBoundary(true) + 'Content-Disposition: form-data; name="audio"; filename=' + extractfilename(od.FileName) + sLineBreak + 'Content-Type: multipart/form-data' + sLineBreak + sLineBreak;
  http.Document.Write(PAnsiChar(s)^, Length(s));
  f := TFileStream.Create(od.FileName, fmOpenRead);
  f.Position := 0;
  http.Document.CopyFrom(f, f.Size);
  f.Free;
  s := sLineBreak + GetBoundary(true);
  http.Document.Write(PAnsiChar(s)^, Length(s));
  s := 'Content-Disposition: form-data; name="title";' + sLineBreak + slinebreak + AnsiToUtf8(' ') + sLineBreak + getboundary(false);
  http.Document.Write(PAnsiChar(s)^, Length(s));
  s := Format('https://api.telegram.org/bot%s/sendAudio', [bot_key]);
  if http.HTTPMethod('POST', s) then
    Memo1.Lines.LoadFromStream(http.Document);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  s: string;
  list: TStringList;
  jo: ISuperObject;
  tod: TSuperArray;
  i: Integer;
begin
  http.Headers.Clear;
  http.Document.Clear;
  s := 'https://api.telegram.org/bot' + bot_key + '/getUpdates?offset=' + last_id;
  if http.HTTPMethod('GET', s) then
  begin
    list := TStringList.Create;
    list.LoadFromStream(http.Document);
    jo := SO(list.Text);
    if jo.B['ok'] = True then
    begin

      tod := jo['result'].AsArray;
      for I := 0 to tod.Length - 1 do
      begin
        last_id := tod[i].S['update_id'];
        Memo1.Lines.Add('kod: ' + tod[i].S['update_id'] + '  ' + tod[i].S['message.from.first_name'] + '  ' + tod[i].S['message.from.last_name'] + '  ' + tod[i].S['message.text']);
        with ListView1.Items.Add do
        begin
          Caption := tod[i].S['message.from.id'];
          SubItems.Add(tod[i].S['message.from.first_name'] + ' ' + tod[i].S['message.from.last_name']);
        end;
      end;

    end;

  end;
  list.Free;
end;

procedure TForm1.CreateConnector;
begin
  http := THTTPSend.Create;
  Http.Sock.CreateWithSSL(TSSLOpenSSL);
  Http.Sock.SSLDoConnect;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  http.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CreateConnector();
end;

end.

